package checkmk

import "fmt"

// Error implements a transfer specific error
type Error struct {
	HostUUID string
	Message  string
	Err      error
}

// Unwrap implements errors.Unwrap
func (e *Error) Unwrap() error {
	return e.Err
}

// Unwrap implements errors.Error
func (e *Error) Error() string {
	host := "Unknown"
	if e.HostUUID != "" {
		host = e.HostUUID
	}
	if e.Err != nil {
		if e.Message != "" {
			return fmt.Sprintf("[%s] checkmk %s: %s", host, e.Message, e.Err.Error())
		}
		return fmt.Sprintf("[%s] checkmk: %s", host, e.Err.Error())
	}
	return fmt.Sprintf("[%s] checkmk %s", host, e.Message)
}
